CREATE ROLE DATABASEMANAGER;
GRANT ALL PRIVILEGES ON clinicalTrials.* TO DATABASEMANAGER WITH GRANT OPTION;

CREATE USER 'dbm'@'%' IDENTIFIED BY 'admin';
GRANT DATABASEMANAGER TO 'dbm'@'%';

-- Atletas da Clinica
CREATE ROLE ATLETA;
GRANT EXECUTE ON PROCEDURE clinicalTrials.checkFutureExams TO ATLETA;
GRANT EXECUTE ON PROCEDURE clinicalTrials.fazerPedidosForProvaInHospital TO ATLETA;
GRANT EXECUTE ON PROCEDURE clinicalTrials.getConsultasPorEspecialidade TO ATLETA;
GRANT EXECUTE ON PROCEDURE clinicalTrials.getExamsDone TO ATLETA;
GRANT EXECUTE ON PROCEDURE clinicalTrials.getExamsNeeded TO ATLETA;
GRANT EXECUTE ON PROCEDURE clinicalTrials.getFuturasProvas TO ATLETA;
GRANT EXECUTE ON PROCEDURE clinicalTrials.getOrganizador TO ATLETA;

CREATE USER 'atleta'@'%' IDENTIFIED BY '12345678';
GRANT ATLETA TO 'atleta'@'%';

-- Diretores de Hospitais
CREATE ROLE DIRETOR;
GRANT EXECUTE ON PROCEDURE clinicalTrials.checkStocks TO DIRETOR;
GRANT EXECUTE ON PROCEDURE clinicalTrials.hireDoc TO DIRETOR;
GRANT EXECUTE ON PROCEDURE clinicalTrials.restoreStocks TO DIRETOR;
GRANT EXECUTE ON PROCEDURE clinicalTrials.addHospital TO DIRETOR;
GRANT EXECUTE ON PROCEDURE clinicalTrials.addOrganizador TO DIRETOR;

CREATE USER 'diretor'@'%' IDENTIFIED BY '12345678';
GRANT DIRETOR TO 'diretor'@'%';

-- Médicos dos Hospitais
CREATE ROLE MEDICO;
GRANT EXECUTE ON PROCEDURE clinicalTrials.atenderPedido TO MEDICO;
GRANT EXECUTE ON PROCEDURE clinicalTrials.atenderPedidoToConsulta TO MEDICO;
GRANT EXECUTE ON PROCEDURE clinicalTrials.addExame TO MEDICO;

CREATE USER 'medico'@'%' IDENTIFIED BY '12345678';
GRANT MEDICO TO 'medico'@'%';

-- Organizadores de Provas
CREATE ROLE ORGANIZADOR;
GRANT EXECUTE ON PROCEDURE clinicalTrials.createProva TO ORGANIZADOR;
GRANT EXECUTE ON PROCEDURE clinicalTrials.getNumAtletasInscritosProva TO ORGANIZADOR;
GRANT EXECUTE ON PROCEDURE clinicalTrials.getNumAtletasModalidade TO ORGANIZADOR;
GRANT EXECUTE ON PROCEDURE clinicalTrials.getProvasSameModalidadeDatas TO ORGANIZADOR;

CREATE USER 'organizador'@'%' IDENTIFIED BY '12345678';
GRANT ORGANIZADOR TO 'organizador'@'%';

-- Membros do Staff
CREATE ROLE STAFF;
GRANT EXECUTE ON PROCEDURE clinicalTrials.addAtleta TO STAFF;
GRANT EXECUTE ON PROCEDURE clinicalTrials.addEquipamento TO STAFF;

CREATE USER 'staff'@'%' IDENTIFIED BY '12345678';
GRANT STAFF TO 'staff'@'%';
